<?php

/**
 * This project has been generated by worker generator
 * has been made by fahmi sulaiman
 * sulaimanfahmi@gmail.com
 * check out my github @dekaulitz
 */

namespace App\Http\Services;

use App\Http\Models\VoyageModel;
use App\Http\Base\BaseService;
use Carbon\Carbon;
use Illuminate\Support\Facades\DB;

class VoyagesService extends BaseService
{
    /**
     * VoyageService constructor.
     */
    public function __construct()
    {
        parent::__construct();
        $this->model = new VoyageModel();
    }

    /**
     *  index function that get all data from database by default
     * @return array|static[]
     */
    public function index()
    {
        return $this->model->getQuery()->orderBy("voyages.voyageKode", "ASC")->get();
    }

    public function getVoyages($request)
    {
        $auth = json_decode($request->session()->get('auth'));
        $currYear =  date('Y');
        return $this->model->getQuery()
            // ->where("voyages.tahun", "=", $currYear)
            ->where("voyages.kapalId", "=", $auth->kapalId)
            ->where(function ($query) {
                $query->where("voyages.call_num", "=", 1)->orWhereRaw(' to_number("voyages"."voyageKode", \'9\') <= \'0\' ');
            })
            ->orderBy("voyages.voyage_from", "DESC")->get();
    }

    public function getVoyageByDate($request, $tglToCheck)
    {
        $auth = json_decode($request->session()->get('auth'));
        $currYear =  date('Y');
        $dataVoyage = $this->model->getQuery()
            ->select(["voyages.voyageKode", "voyages.voyageName"])
            ->selectRaw(' TO_CHAR("voyages"."voyage_from", \'YYYY-MM-DD\') AS "voyage_from" ')
            ->selectRaw(' TO_CHAR("voyages"."voyage_to", \'YYYY-MM-DD\') AS "voyage_to" ')
            // ->where("voyages.tahun", "=", $currYear)
            ->where("voyages.kapalId", "=", $auth->kapalId)
            ->where(function ($query) use ($tglToCheck) {
                $query->where(function ($Q) use ($tglToCheck) {
                    $Q->where("voyages.voyage_from", "<=", Carbon::parse(str_replace(" ", "+", $tglToCheck))->toDateTimeString())
                        ->where("voyages.voyage_to", ">=", Carbon::parse(str_replace(" ", "+", $tglToCheck))->toDateTimeString())
                        ->where("voyages.call_num", "=", 1);
                })
                    ->orWhereRaw(' to_number("voyages"."voyageKode", \'9\') <= \'0\' ');
            })
            ->orderBy("voyages.voyage_from", "DESC")
            ->get();
        return $dataVoyage;
    }

    public function getFutureVoyageByDate($request, $tglToCheck)
    {
        $auth = json_decode($request->session()->get('auth'));
        $dataFutureVoyage = (new VoyageModel())->getQuery()
            ->select(["voyages.voyageKode", "voyages.voyageName"])
            ->selectRaw(' TO_CHAR("voyages"."voyage_from", \'YYYY-MM-DD\') AS "voyage_from" ')
            ->selectRaw(' TO_CHAR("voyages"."voyage_to", \'YYYY-MM-DD\') AS "voyage_to" ')
            ->where("voyages.kapalId", "=", $auth->kapalId)
            ->where("voyages.call_num", "=", 1)
            ->where("voyages.voyage_from", ">", Carbon::parse(str_replace(" ", "+", $tglToCheck))->toDateTimeString())
            ->orderBy("voyages.voyage_from", "ASC")
            ->limit(1)
            ->get();

        $dataVoyage = $this->getVoyageByDate($request, $tglToCheck);

        $data = array_merge($dataFutureVoyage, $dataVoyage);
        return $data;
    }

    public function getVoyagesByDateRange($request)
    {
        $auth = json_decode($request->session()->get('auth'));
        $input = $request->all();
        $currYear =  date('Y');
        $dateVoyage = [$input["dateStart"], $input["dateEnd"]];

        $dataVoyage = $this->model->getQuery()
            ->select(["voyages.voyageKode", "voyages.voyageName"])
            ->selectRaw(' TO_CHAR("voyages"."voyage_from", \'YYYY-MM-DD\') AS "voyage_from" ')
            ->selectRaw(' TO_CHAR("voyages"."voyage_to", \'YYYY-MM-DD\') AS "voyage_to" ')
            // ->where("voyages.tahun", "=", $currYear)
            ->where("voyages.kapalId", "=", $input["kapalId"])
            ->where(function ($query) use ($dateVoyage) {
                $query->where(function ($Q) use ($dateVoyage) {
                    $Q->where("voyages.voyage_from", ">=", Carbon::parse(str_replace(" ", "+", $dateVoyage[0]))->toDateTimeString())
                        ->where("voyages.voyage_from", "<=", Carbon::parse(str_replace(" ", "+", $dateVoyage[1]))->toDateTimeString())
                        ->where("voyages.call_num", "=", 1);
                })
                    ->orWhere(function ($Q) use ($dateVoyage) {
                        $Q->where("voyages.voyage_to", ">=", Carbon::parse(str_replace(" ", "+", $dateVoyage[0]))->toDateTimeString())
                            ->where("voyages.voyage_to", "<=", Carbon::parse(str_replace(" ", "+", $dateVoyage[1]))->toDateTimeString())
                            ->where("voyages.call_num", "=", 1);
                    })
                    ->orWhere(function ($Q) use ($dateVoyage) {
                        $Q->where("voyages.voyage_from", "<=", Carbon::parse(str_replace(" ", "+", $dateVoyage[0]))->toDateTimeString())
                            ->where("voyages.voyage_to", ">=", Carbon::parse(str_replace(" ", "+", $dateVoyage[1]))->toDateTimeString())
                            ->where("voyages.call_num", "=", 1);
                    })
                    ->orWhereRaw(' to_number("voyages"."voyageKode", \'9\') <= \'0\' ');
            })
            ->orderBy("voyages.voyage_from", "DESC")
            ->get();
        return $dataVoyage;
    }

    /**
     *  this function is magic pagination injector from my library you want to add new property or field you have to inject into model in alias paging property
     * @param array $input
     * @return array
     */
    public function paging($input)
    {
        $this->model->getQuery()->select(["voyages.*"])->where("voyages.enabled_flex", "=", "Y");
        $this->model->paging()->filter()->sorting();
        return $this->model->paging()->getPaging();
    }

    /**
     *  get one raw row data from table by id
     *  you can ad the relation like $this->model->joinSomething()->getQuery()->where("aliastable.field","=",$value)->first()
     *  or like $this->model->joinSomething()->getQuery()->where("aliastable.field","=",$value)->select(["aliastable.fieldname"])->first(); its mean you want to join an take spesific value
     *  and you want to take value like this $model->fieldname
     * @param $id
     * @return VoyageModel
     */
    public function show($value, $field = "id", $operator = "=")
    {
        $model = $this->model->getQuery()->where("voyages." . $field, $operator, $value)->first();
        return $model;
    }

    /**
     *  this is a base function for storing data you with transaction by default
     *  you can customization base on your business requirement as you want, you can add other object or you can to loop anc excecute the process in single process
     * @param array $input
     * @return VoyageModel
     * @throws \Exception
     */
    public function store($input)
    {
        $this->model->fill($input);
        $maxID = $this->model->getQuery()->orderBy("id", "desc")->first();
        if (is_object($maxID)) {
            $this->model->id = $maxID->id + 1;
        } else {
            $this->model->id = 1;
        }

        if (!$this->model->save()) {
            throw new \Exception();
        }
        return $this->model;
    }


    /**
     * this function will delete much data, in one action
     * the ids is a parameter from view like 1,2,3,4 and the parameter will be exploded into single array
     * you can remove this main alogorithm with your business requirement like soft delete or anything you want
     * @param $ids
     */
    public function delete($ids)
    {
        $params = explode(".", $ids);
        $this->model->deleteBulk("id", $params);
    }


    /**
     *  this is a base function for update and delete data by default.
     *  you can add and custom as you want base on your requirement you can add this function as core function for handle update data from table or
     *  you can add multiple relation proses after update in this function
     * @param $id
     * @param array $input
     * @return VoyageModel
     * @throws \Exception
     */
    public function update($id, $input)
    {
        $voyage = VoyageModel::find($id);
        $voyage->fill($input);
        if (!$voyage->update()) {
            throw new \Exception();
        }
        return $voyage;
    }


    /**
     *  this function will be confirting paging property into file excel
     *  the main library is base on excel spreadsheet library
     * @param array $input
     * @return array|static[]
     */
    public function exportToExcel($input = array())
    {
        return $this->model->getQuery()->where("voyages.enabled_flex", "=", "Y")->get();
    }
    public function getNonVoyage()
    {
        return $this->model->getQuery()->distinct()->select(["voyageKode", "voyageName"])->where("voyages.voyageKode", "<=", 1)->get();
    }
}
